(function(document) {
	var last;
	var lastStyle;	
	/**
	 * Get full CSS path of any element
	 * 
	 * Returns a jQuery-style CSS path, with IDs, classes and ':nth-child' pseudo-selectors.
	 * 
	 * Can either build a full CSS path, from 'html' all the way to ':nth-child()', or a
	 * more optimised short path, stopping at the first parent with a specific ID,
	 * eg. "#content .top p" instead of "html body #main #content .top p:nth-child(3)"
	 */
	function cssPath(el) {
		var fullPath    = 0,  // Set to 1 to build ultra-specific full CSS-path, or 0 for optimised selector
		    useNthChild = 0,  // Set to 1 to use ":nth-child()" pseudo-selectors to match the given element
		    cssPathStr = '',
		    testPath = '',
		    parents = [],
		    parentSelectors = [],
		    tagName,
		    cssId,
		    cssClass,
		    tagSelector,
		    vagueMatch,
		    nth,
		    i,
		    c;
		var originalElement=el;//store our original node
		// Go up the list of parent nodes and build unique identifier for each:
		/*while ( el ) {
			vagueMatch = 0;

			// Get the node's HTML tag name in lowercase:
			tagName = el.nodeName.toLowerCase();
			
			// Get node's ID attribute, adding a '#':
			cssId = ( el.id ) ? ( '#' + el.id ) : false;
			
			// Get node's CSS classes, replacing spaces with '&':
			cssClass = ( el.className ) ? ( '.' + el.className.replace(/\s+/g,"&") ) : '';

			// Build a unique identifier for this parent node:
			if ( cssId ) {
				// Matched by ID:
				tagSelector = tagName + cssId + cssClass;
			} else if ( cssClass ) {
				// Matched by class (will be checked for multiples afterwards):
				tagSelector = tagName + cssClass;
			} else {
				// Couldn't match by ID or class, so use ":nth-child()" instead:
				vagueMatch = 1;
				tagSelector = tagName;
			}
			
			// Add this full tag selector to the parentSelectors array:
			parentSelectors.unshift( tagSelector )

			// If doing short/optimised CSS paths and this element has an ID, stop here:
			if ( cssId && !fullPath )
				break;
			
			// Go up to the next parent node:
			el = el.parentNode !== document ? el.parentNode : false;
			
		} // endwhile
		*/
		
	
		
		
		
		
		//cssPathStr=originalElement.nodeName+"\n"+originalElement.innerHTML;
		return getElementXPath(originalElement);//return the XPath
		
		//cssPathStr+=" "+originalElement.parentNode;
		//cssPathStr+=" Style:"+lastStyle;
		// Return trimmed full CSS path:
		//return cssPathStr.replace(/^[ \t]+|[ \t]+$/, '');
	}


	/**
	 * MouseOver action for all elements on the page:
	 */
	function inspectorMouseOver(e) {
		// NB: this doesn't work in IE (needs fix):
		var element = e.target;
		lastStyle="";
		if (element.hasAttribute('style')) {
			lastStyle = element.getAttribute('style'); 
			if (lastStyle =="") {
				//alert("hello: '"+element.getAttribute("style")+ "'");
				lastStyle="";
			}
			
		} else {
			lastStyle="";
		}
		// Set outline:
		//
		element.style.outline = '2px solid #f00';
		// Set last selected element so it can be 'deselected' on cancel.
		last = element;
		window.status= (cssPath(e.target));
	}
	
	
	/**
	 * MouseOut event action for all elements
	 */
	function inspectorMouseOut(e) {
		// Remove outline from element:
		//e.target.removeAttribute("style");
		if (lastStyle=="" || lastStyle=="null") {
			e.target.style.outline='';
			e.target.setAttribute("style","")

			e.target.removeAttribute("style");
		} else {
			e.target.setAttribute("style",lastStyle)
			//e.target.style = lastStyle;
			lastStyle="";
		}
	}
	
	
	/**
	 * Click action for hovered element
	 */
	function inspectorOnClick(e) {
		e.preventDefault();
		
		// These are the default actions (the XPath code might be a bit janky)
		// Really, these could do anything:
		//console.log( cssPath(e.target) );
		/* console.log( getXPath(e.target).join('/') ); */
		 //window.status= (cssPath(e.target));
		 window.status= "Click:"+(cssPath(e.target));
		return false;
	}

	function getElementXPath(elt)
	{
	     var path = "";
	     for (; elt && elt.nodeType == 1; elt = elt.parentNode)
	     {
	   	idx = getElementIdx(elt);
		xname = elt.tagName;
		if (idx > 1) xname += "[" + idx + "]";
		path = "/" + xname + path;
	     }
	 
	     return path;	
	}

	function getElementIdx(elt)
	{
	    var count = 1;
	    for (var sib = elt.previousSibling; sib ; sib = sib.previousSibling)
	    {
	        if(sib.nodeType == 1 && sib.tagName == elt.tagName)	count++
	    }
	    
	    return count;
	}
	
	
	function setLinks() {
	var theLinks = document.getElementsByTagName("a");
	for(var i = 0; i < theLinks.length; i++)
	{
		theLinks[i].onclick = function()
		{
			return false;
		}
	}
	
	}
	onload = setLinks;


	/**
	 * Add event listeners for DOM-inspectorey actions
	 */
	if ( document.addEventListener ) {
		document.addEventListener("mouseover", inspectorMouseOver, true);
		document.addEventListener("dragenter", inspectorMouseOver, true);
		document.addEventListener("mouseout", inspectorMouseOut, true);
		document.addEventListener("dragleave", inspectorMouseOut, true);
		document.addEventListener("mouseup", inspectorOnClick, true);
		document.addEventListener("keydown", inspectorCancel, true);
	
	}
	
})(document);
